#include "stdafx.h"
#include "PIPMasq.h"

bool getAdapterInfo2(
	const char* nicName,		// input
	char* AdapterName,			// output
	unsigned char*	macAddr,	// output	
	char* ipAddress,			// output				
	char* maskAddress			// output		
);

////////////////////////// PseudIF /////////////////////////////////

PseudIF::PseudIF(
	const char* wanNicName, 
	const char* pseudIPAddr,
	unsigned const char* defaultGWMacAddr)
{
	//////////
	memset(m_wanAdapterName, 0 , sizeof(m_wanAdapterName));

	strcpy(m_wanNicName, wanNicName);
	if (getAdapterInfo2(
		m_wanNicName, m_wanAdapterName, m_wanMacAddr, m_wanIPAddr, m_wanMaskAddr))
		m_pseudLpAdapter = PacketOpenAdapter(m_wanAdapterName);
	else
		return;

	memcpy(m_pseudMacAddr, m_wanMacAddr, ETH_ALEN);
	memcpy(m_defaultGWMacAddr, defaultGWMacAddr, ETH_ALEN);

	PacketSetHwFilter(m_pseudLpAdapter,NDIS_PACKET_TYPE_DIRECTED);

	if((m_pseudLpPacket = PacketAllocatePacket())==NULL)
	{
  	 	sprintf(m_message,"\nError:failed to allocate the LPPACKET structure."); 
	 	return;
	}	
	
	PacketInitPacket(m_pseudLpPacket,(char*)m_pseudBuffer, MAX_ETH_SIZE);

	//////////
	m_wanIPAddr_u32 = htonl(inet_addr(m_wanIPAddr));
	m_pseudIPAddr_u32 = htonl(inet_addr(pseudIPAddr));
	m_subWanIPAddr_u32 = htonl(inet_addr(m_wanMaskAddr));
	m_netWanAddr_u32 = (m_wanIPAddr_u32 & m_subWanIPAddr_u32);

	//////////

	m_pseudIFLock = CreateMutex(0, FALSE, "pseudIFLock");

}

PseudIF::~PseudIF()
{
	PacketFreePacket(m_pseudLpPacket);
	PacketCloseAdapter(m_pseudLpAdapter);

	printf(".....PseudIF is destructed.\n");
//	Sleep(1000);	

}

bool
PseudIF::releasePacket(void* packet, int dataLen)
{
	WaitForSingleObject(m_pseudIFLock, INFINITE);	

	// Release Preparation
	PacketInitPacket(m_pseudLpPacket, (void *)packet, dataLen);

	// Release !
	BOOLEAN truefalse = PacketSendPacket(m_pseudLpAdapter,m_pseudLpPacket,TRUE);

	ReleaseMutex(m_pseudIFLock);

	return true;
}
